﻿-- Persistent Data for TellTrack, Saved Variables

TellTrack = LibKarma:GetInstance( "TellTrack", {

} )

TellTrack:RegisterDB( "TellTrackDB", {
	Options = {
		AutoCreate = 1,
		Border = 0,
		DebugMode = 0,
		Enable = 1,
		HideWhispers = 0,
		ListInvert = 0,
		LineNums = 0,
		ListSave = 1,
		ListSize = 30,
		MessageCount = 400,
		MessageSave = 1,
		ShowAll = 0,
		TimeStamps = 0,
		WhisperFirst = 0,
		-- Internal flags
		Color = "|c0076dfff",			-- optional text accent color
		Faction = nil,
		LastLang = nil,
		LastTell = nil,
		ListOffset = 1,
		ListProfile = nil,
		Player = nil,					-- current logged in player name
		PlayerProfile = nil,
		Race = nil,						-- current player race
		Realm = nil,					-- current realm
		VersionCopy = 0,                -- [0|1]  Is imported, one time thing very first load only
		VersionFix = 6,					-- [0...]  Current database version level
	},
	Log = { },
	Chat = { },
} )

function TellTrack:RunVersionFix( frame )
	local db = self._db
	local log = db.Log
	local o = self._options
	o.VersionFix = o.VersionFix			-- copy and force default value to get saved
	--o.datalog = "nom"

	if o.VersionCopy == 0 then
		if TellTrack_SavedList then
			self:Print("Importing TellTrack database.")
			self:ImportToDB( o, _G, "TellTrack_", false, true, { "Enabled", "HideBorder", "InvertedList", "DontSaveList",
				"AutoWhisperFrame", "HideOtherWhispers", "TimeStamps", "WhisperFirst", } )
			self:ImportToDB( nil, _G, "TellTrack_", false, true, { Chat="WhisperChatFrame", Log="SavedList",} )
		end
		o.VersionCopy = 1
	end

	local t,c,c2,c3,d,d2
	if o.VersionFix >= 0 and o.VersionFix <= 2 then									--self:Debug("VersionFix", 1,2,3)
		if o.DontSaveList then o.DontSaveList = (o.DontSaveList == 1) and 0 or 1 end
		self:ImportRenameDB( o, { "AutoCreate","AutoWhisperFrame","CurentList","ButtonCount",
			Enable="Enabled",HideWhispers="HideOtherWhispers",Border="HideBorder",ListInvert="InvertedList",ListSave="DontSaveList", } )

		for k,v in pairs(log) do
			c,c2 = strsplit("_", k, 2); if c2 then c=c.." - "..c2; log[c] = v; log[k] = nil; end
			for i1,v1 in pairs(v) do
				if type(v1)=="string" then
					v1 = { name = v1, compareName = v1:lower(), unread = 0, sentTo = false, }; v[i1] = v1
				end
				if type(v1)~="table" then tremove(i1) end
				if not v1.unread then v1.unread = 0 end
				if not v1.dispName then v1.dispName = v1.name end
				if v1.compareName then v1.cmpName = v1.compareName; v1.compareName = nil; end
			end
		end
		for k,v in pairs(db.Chat) do
			for k1,v1 in pairs(v) do
				if o.VersionFix == 0 and type(v1) ~= "table" then v1 = { name=nil, frame=v1 }; v[k1] = v1 end
				if type(v1) == "table" then	db.Chat[k1.." - "..k] = v1; db.Chat[k] = nil end
			end
		end
		o.VersionFix = 3
	end
	if o.VersionFix >= 3 and o.VersionFix <= 5 then									--self:Debug("VersionFix", 4,5,6)
		c2,c3 = o.RealmPostfix or "-"..(GetRealmName()), o.RealmPostfixCmp or "-"..(TellTrack:LowerUTF8(GetRealmName()))
		for k,v in pairs(log) do
			d,d2 = {},{}
			for i1,v1 in pairs(v) do
				c = v1.dispName; if c then c = self:CapUTF8(c); v1.dispName = c end
				if c and not c:find("-") then v1.dispName = c .. c2 end
				c = v1.name; if c and not v1.target then v1.target = c end
				if c and not c:find("-") then v1.name = c .. c2 end
				c = v1.cmpName; if c and not c:find("-") then c = c .. c3; v1.cmpName = c end
				if not d2[c] then d2[c] = 1; tinsert(d, v1) end
			end
			log[k] = d
		end
		if db.Chat then
			for k,v in pairs(db.Chat) do
				c = v.name;	if c then c = self:CapUTF8(c); v.name = c end
				if c and not c:find("-") then v.name = c .. c2 end
			end
		end
		o.VersionFix = 6
	end
	if o.VersionFix >= 6 and o.VersionFix <= 6 then									--self:Debug("VersionFix", 7)
		if db.Chat then
			for k,v in pairs(db.Chat) do
				if ChatFrame_AddMessageGroup and v.frame and _G[v.frame] then
					ChatFrame_AddMessageGroup(_G[v.frame], "BN_WHISPER")
				end
			end
		end
		o.VersionFix = 7
	end
end
